#define EJUDGE 1

#include <iostream>
#include "testlib.h"
#include <cassert>

using namespace std;
const int Nmax = 10;
int N;
int a[Nmax][Nmax];
int score;

void move(char c)
{
    switch (c) {
        case 'L':
            for (int i = 1; i <= N; ++i) {
                int k = 1;
                bool f = false;
                for (int j = 1; j <= N; ++j)
                    if (a[i][j] > 0) {
                        if (a[i][k - 1] == a[i][j] && f) {
                            a[i][k - 1] *= 2;
                            score += a[i][k - 1];
                            a[i][j] = 0;
                            f = false;

                        }
                        else {
                            a[i][k] = a[i][j];
                            f = true;
                            if (j > k) {
                                a[i][j] = 0;
                            }
                            ++k;
                        }
                    }
            }

            break;
        case 'R':
            for (int i = 1; i <= N; ++i) {
                int k = N;
                bool f = false;
                for (int j = N; j >= 1; --j)
                    if (a[i][j] > 0) {
                        if (a[i][k + 1] == a[i][j] && f) {
                            a[i][k + 1] *= 2;
                            score += a[i][k + 1];
                            a[i][j] = 0;
                            f = false;

                        }
                        else {
                            a[i][k] = a[i][j];
                            f = true;
                            if (j < k) {
                                a[i][j] = 0;
                            }
                            --k;
                        }
                    }
            }
            break;
        case 'U':
              for (int j = 1; j <= N; ++j) {
                int k = 1;
                bool f = false;
                for (int i = 1; i <= N; ++i)
                    if (a[i][j] > 0) {
                        if (a[k - 1][j] == a[i][j] && f) {
                            a[k - 1][j] *= 2;
                            score += a[k - 1][j];
                            a[i][j] = 0;
                            f = false;

                        }
                        else {
                            a[k][j] = a[i][j];
                            f = true;
                            if (i > k) {
                                a[i][j] = 0;
                            }
                            ++k;
                        }
                    }
            }
            break;
        case 'D':
            for (int j = 1; j <= N; ++j) {
                int k = N;
                bool f = false;
                for (int i = N; i >= 1; --i)
                    if (a[i][j] > 0) {
                        if (a[k + 1][j] == a[i][j] && f) {
                            a[k + 1][j] *= 2;
                            score += a[k + 1][j];
                            a[i][j] = 0;
                            f = false;

                        }
                        else {
                            a[k][j] = a[i][j];
                            f = true;
                            if (i < k) {
                                a[i][j] = 0;
                            }
                            --k;
                        }
                    }
            }
            break;
    }

}

void printmove() {
    printf("score %d\n", score);
    for (int i = 1; i <= N; ++i) {
    	printf("%d %d %d %d\n", a[i][1], a[i][2], a[i][3], a[i][4]);
    }
}

bool addNew() {
    vector<pair<int, int>> available_cells;

    for (int i = 1; i <= N; ++i) {
	for (int j = 1; j <= N; ++j) {
	    if (a[i][j] == 0) {
		available_cells.emplace_back(i,j);
	    }
	}
    }
    if (available_cells.size() == 0) {
	 return false;
    }
    int r1 = rand();
    int r2 = rand();
    int value = (r1 / ((1LL << 31) + 1.0)) < 0.9 ? 2 : 4;
    int pos = (r2 / ((1LL << 31) + 1.0)) * available_cells.size();
    int x = available_cells[pos].first;
    int y = available_cells[pos].second;
    printf("%d %d %d %d\n", value, pos, x, y);
    assert(a[x][y] == 0);
    a[x][y] = value;
    return true;
}

int main(int argc, char *argv[])
{
    registerTestlibCmd(argc, argv);
    int K, L, x, y, m;

    char c;
    N = 4;
    int seed = inf.readInt();
    srand(seed);
    int pat_score = ouf.readInt();
    ouf.readLine();
    string moves = ouf.readLine();

    L = moves.size();

    addNew();
    addNew();

    printmove();

    for (int i = 0; i < L; ++i) {
	c = moves[i];
        move(c);
	addNew();
	//printmove();
    }

    if (addNew()) {
	quit(_pe, "exist available cells");
    }

    int t_score = score;
    for (auto c : {'U', 'D', 'L', 'R'}) {
	move(c);
    }


    if (score != t_score) {
	quitf(_pe, "exists move");
    }

    quitf(_ok, "score %d", score);
    /*
    for (int i = 1; i <= N; ++i) {
             for (int j = 1; j <= N; ++j) {
                 cout << a[i][j] << " ";
             }
             cout << endl;
    }
    */
    return 0;
}
