/* -*- mode: c; c-basic-offset: 4 -*- */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <time.h>

int main(int argc, char *argv[])
{
    if (argc != 3) abort();
    const char *year_str = argv[1];
    const char *num_str = argv[2];

    int year = 0;
    {
        errno = 0;
        char *eptr = NULL;
        long val = strtol(year_str, &eptr, 10);
        if (errno || *eptr || eptr == year_str || (int)  val != val || val < 1902 || val > 2037) abort();
        year = val;
    }
    int num = 0;
    {
        errno = 0;
        char *eptr = NULL;
        long val = strtol(num_str, &eptr, 10);
        if (errno || *eptr || eptr == num_str || (int) val != val || val <= 0) abort();
        num = val;
    }

    putenv("TZ=UTC");

    struct tm d = {};
    d.tm_year = year - 1900;
    d.tm_mon = 0;
    d.tm_mday = 0;
    d.tm_hour = 12;
    d.tm_min = 0;
    d.tm_sec = 0;
    int day_in_row = 0;
    int cur_count = 0;

    while (1) {
        ++d.tm_mday;
        d.tm_isdst = -1;
        mktime(&d);
        if (d.tm_year + 1900 != year) {
            // not enough days
            printf("0 0\n");
            break;
        }
        if (d.tm_wday != 0 && d.tm_wday != 6) {
            if (++day_in_row == 4) {
                if (++cur_count == num) {
                    printf("%d %d\n", d.tm_mon + 1, d.tm_mday);
                    break;
                }
                //printf(">>%d %d %d\n", ++cur_count, d.tm_mon + 1, d.tm_mday);
                day_in_row = 0;
            }
        }
    }
}
